app/urls.py
from django.urls import include,path
from app import views


urlpatterns = [
    path('', views.home, name='home'),
    path('about/', views.about, name='about'),
    path('about/donate/', views.donate, name='donate'),
    path('about/collaborate/', views.collaborate, name='collaborate'),
    path('search/', views.search, name='search'),

    path('profile/login/', views.login, name='login'),
    path('profile/login/settings/', views.profile_edit, name='settings'),
    path('profile/registration/', views.registration, name='registration'),
    path('profile/logout/', views.logout, name='logout'),
    path('profile/', views.profile, name='profile'),

    path('courses/', views.courses, name='courses'),
    path('courses/<slug:course>/', views.course, name='course'),
    path('courses/<slug:course>/<slug:lesson>/', views.lesson, name='lesson'),

    path('add-likes/', views.like, name='like'),
    path('terms-of-use/', views.terms, name='terms'),
    path('privacy-policy/', views.privacy, name='privacy'),
    path('captions/caption_<int:id>.vtt', views.captions, name='captions')
]

djangocode/urls.py
from django.contrib import admin
from django.urls import include,path
from app import urls
from django.conf import settings
from django.conf.urls.static import static


urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('app.urls')),
]

urlpatterns += static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)
urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

handler404 = 'app.views.page_not_found_view'
handler500 = 'app.views.error_view'
# handler403 = 'app.views.my_custom_permission_denied_view'
# handler400 = 'app.views.my_custom_bad_request_view'

app/forms.py
from django import forms
from django.contrib.auth.models import User

class RegistrationForm(forms.ModelForm):
    email = forms.CharField(widget=forms.EmailInput(attrs={'autocomplete': 'off', 'autocorrect': 'off', 'autocapitalize': 'none'}))
    first_name = forms.CharField(required=True)
    last_name = forms.CharField(required=True)
    password = forms.CharField(widget=forms.PasswordInput(attrs={'autocomplete': 'off'}))

    class Meta:
        model = User
        fields = ['email', 'first_name', 'last_name', 'password', ]

    def __init__(self, *args, **kwargs):
        super(RegistrationForm, self).__init__(*args, **kwargs)
        self.fields['email'].label = 'E-mail'
        self.fields['first_name'].label = 'Имя'
        self.fields['last_name'].label = 'Фамилия'
        self.fields['password'].label = 'Пароль'

    def clean(self):
        email = self.cleaned_data['email']
        if User.objects.filter(username=email).exists():
            raise forms.ValidationError('Кто то уже зарегистрирован с данной почтой, может это вы?')

class LoginForm(forms.Form):
    username = forms.CharField()
    password = forms.CharField(widget=forms.PasswordInput())

    def __init__(self, *args, **kwargs):
        super(LoginForm, self).__init__(*args, **kwargs)
        self.fields['username'].label = 'E-mail'
        self.fields['password'].label = 'Пароль'

    def clean(self):
        username = self.cleaned_data['username']
        password = self.cleaned_data['password']

        if not User.objects.filter(username=username).exists():
            raise forms.ValidationError('Неверный e-mail или пароль')
        user = User.objects.get(username=username)
        if not user.check_password(password):
            raise forms.ValidationError('Неверный e-mail или пароль')

class CommentForm(forms.Form):
    # lesson = forms.CharField(widget = forms.HiddenInput())
    text = forms.CharField(widget=forms.Textarea(attrs={'placeholder': 'Напишите свой бесценный комментарий'}), required=True)

    def __init__(self, *args, **kwargs):
        super(CommentForm, self).__init__(*args, **kwargs)

class SearchForm(forms.Form):
    search = forms.CharField()

    def __init__(self, *args, **kwargs):
        super(SearchForm, self).__init__(*args, **kwargs)

class CollaborateForm(forms.Form):
    name = forms.CharField()
    email = forms.CharField(widget=forms.EmailInput())
    reason = forms.CharField(widget=forms.TextInput())

    def __init__(self, *args, **kwargs):
        super(CollaborateForm, self).__init__(*args, **kwargs)

class DonateForm(forms.Form):
    sum = forms.CharField()
    comment = forms.CharField(widget=forms.TextInput(), required=False)

    def __init__(self, *args, **kwargs):
        super(DonateForm, self).__init__(*args, **kwargs)

app/templates/courses/lesson.html
{% extends 'base.html' %}
{% load static %}
{% load markdown_deux_tags %}
{% load humanize %}
{% block seo %}
<title>{{ lesson.title }} - {{ lesson.course.title }}</title>
<meta name='description' content='{{ lesson.about }}' />
<meta property="og:image" content="https://djangocode.com{{ lesson.course.cover.url }}" />
<meta property="og:title" content="{{ lesson.title }}. {{ lesson.course.title }}" />
<meta property="og:description" content="{{ lesson.about }}" />
{% endblock seo %}
{% block content %}
<div class="lesson">
  <div class="lesson-head" style="background-image: url({{ lesson.course.cover.url }});">
    <div class="cover">
      <div class="info">
        <h1>{{ lesson.course.title }}</h1>
        <div class="info-number">урок #{{ lesson.number }}</div>
        <p>{{ lesson.course.description }}</p>
        <p>{{ lesson.about }}</p>
      </div>
      <div class="data">
        <div><i class="fas fa-tag"></i></div>
        {% for tag in lesson.tags %}
          <div>{{ tag }}</div>
        {% endfor %}
      </div>
    </div>
    <div class="lesson-head-lines">
      <div class="lesson-head-lines-line"></div> <div class="lesson-head-lines-line"></div> <div class="lesson-head-lines-line"></div> <div class="lesson-head-lines-line"></div> <div class="lesson-head-lines-line"></div> <div class="lesson-head-lines-line"></div> <div class="lesson-head-lines-line"></div>
    </div>
  </div>
  <div class="lesson-content">
    <h5>видеоурок</h5>
    <div class="lesson-content-video">
      <video class="js-player" playsinline controls>
          <source src="{{ lesson.video.url }}" type="video/mp4">
          {% if lesson.captions %}
          <track kind="captions" label="English captions" src="{% url 'captions' lesson.id %}" srclang="en" default>
          {% endif %}
      </video>
    </div>
    <h5>все уроки данного курса</h5>
    <div class="lesson-content-course">
      {% for item in lessons %}
        <div class="lesson-content-course__item">
          <div class="icon">
            <i class="fas fa-video"></i>
          </div>
          <div class="info">
            <div class="info-number {% if item.id == lesson.id %}current{% endif %}">урок #{{item.number}}</div>
            <h6>{{item.title}}</h6>
          </div>
        </div>
      {% endfor %}
    </div>
    <h5>релиз</h5>
    <div class="lesson-content-data">
      <div class="data-row">
        <div class="data">
          <div class="data-icon"><i class="fas fa-code-branch"></i>релиз</div>
          <div class="data-info"><a href="{{ lesson.release_link }}">{{ lesson.release_name }}</a></div>
        </div>
        <div class="data">
          <div class="data-icon"><i class="far fa-file-archive"></i>файл</div>
          <div class="data-info"><a href="{{ lesson.release.url }}">zip</a></div>
        </div>
      </div>
      <div class="data-row">
        <div class="data">
          <div class="data-icon"><i class="far fa-calendar-alt"></i>добавлен</div>
          <div class="data-info">{{ lesson.date_add|date:"d.m.Y" }}</div>
        </div>
        <div class="data">
          <div class="data-icon"><i class="fas fa-weight-hanging"></i>размер</div>
          <div class="data-info">{{ lesson.release.size|filesizeformat }}</div>
        </div>
      </div>
    </div>
    <h5>обновления / исправления</h5>
    <div class="grid grid-2">
      {% for update in lesson.updates.all %}
        <div class="grid-item lesson-content-video lesson-content-video--upd">
          <video class="js-player" playsinline controls>
              <source src="{{ update.file.url }}" type="video/mp4">
          </video>
        </div>
      {% endfor %}
    </div>
    <h5>заметки</h5>
    {% for note in lesson.notes.all %}
      <pre>
        <code class="{{ note.language }}">{{ note.code }}</code>
      </pre>
    {% endfor %}
    <h5>комментарии</h5>
    <div class="comments">
      <div class="comments-add">
        {% if request.user.id %}
        <form class="comment-form" autocomplete="off" data-action="{% url 'lesson' lesson.course.slug lesson.slug %}" action="/404/" method="post">
          {% csrf_token %}
          <div class="helper-desc">
            <i class='fab fa-markdown' title="Комментарии поддерживают Markdown разметку"></i>
            <span>*курсив*</span> <span>**жирный**</span> <span>```код (или 4 пробела)```</span> <span>&gt; цитата</span> <span>* список</span>
          </div>
          <textarea name="text" id="id_text" placeholder="Напишите свой бесценный комментарий" required></textarea>
          <button type="submit" name="button">Добавить</button>
        </form>
        {% else %}
        <div class="error">
          <h5>Чтобы оставить комментарий,
            <a href="{% url 'login' %}">войдите</a> или
            <a href="{% url 'registration' %}">зарегистрируйтесь</a></h5>
        </div>
        {% endif %}
      </div>
      <div class="comments-list">
        {% for comment in comments %}
          <div class="comments-list-item{% if comment.user.is_superuser %} comments-list-item-admin{% endif %}">
            <div class="comments-list-item-head">{{ comment.user.first_name }} {{ comment.user.last_name }}, {{ comment.date_add|naturaltime }}</div>
            <div class="comments-list-item-body">
              {{ comment.text|markdown }}
            </div>
            <div class="comments-list-item-footer">
              <span id="comment-{{ comment.id }}">{{ comment.like_count }}</span>
              <i data-comment-id="{{ comment.id }}" class="fas fa-thumbs-up {% if user in comment.likes.all %}liked{% endif %}"></i>
            </div>
          </div>
        {% endfor %}
      </div>
    </div>
  </div>
</div>
{% endblock content %}

app/templates/courses/list.html
{% extends 'base.html' %}
{% load static %}
{% load humanize %}
{% block content %}
{% spaceless %}
<div class="grid">
    {% for course in courses %}
      <div class="grid-item">
        <a href="{% url 'course' course.slug %}">
          <div class="placeholder img" data-large="{{ course.preview.url }}">
            <img src="{{ course.blur.url }}" class="img-small" />
            <div style="padding-bottom: 131.5%;"></div>
          </div>
          <div class="about">
            <time>{{ course.date_add|naturalday }}</time>
            <h5>{{ course.title }}</h5>
          </div>
        </a>
      </div>
    {% empty %}
      <div class="error">
        <h5>пока курсов нет</h5>
      </div>
    {% endfor %}
</div>
{% endspaceless %}
{% endblock content %}

app/templates/courses/main.html
{% extends 'base.html' %}
{% load static %}
{% load humanize %}
{% block content %}
{% spaceless %}
<div class="lesson">
  <div class="lesson-head" style="background-image: url({{ course.cover.url }});">
    <div class="cover">
      <div class="info">
        <h1>{{ course.title }}</h1>
        <div class="info-number">{{lessons|length}} урок</div>
        {# <h5>Описание курса</h5> #}
        <p>Дата добавления: {{ course.date_add|naturalday }}</p>
        <p>{{ course.description }}</p>
      </div>
      <div class="data">
        <div></div>
      </div>
    </div>
    <div class="lesson-head-lines">
      <div class="lesson-head-lines-line"></div> <div class="lesson-head-lines-line"></div> <div class="lesson-head-lines-line"></div> <div class="lesson-head-lines-line"></div> <div class="lesson-head-lines-line"></div> <div class="lesson-head-lines-line"></div> <div class="lesson-head-lines-line"></div>
    </div>
  </div>
  <div class="grid">
      {% for lesson in lessons %}
        <div class="grid-item">
          <a href="{% url 'lesson' course.slug lesson.slug %}">
            <div class="placeholder img" data-large="{{ course.preview.url }}">
              <img src="{{ course.blur.url }}" class="img-small" />
              <div style="padding-bottom: 131.5%;"></div>
            </div>
            <div class="about">
              <time>{{ lesson.date_add|naturalday }}</time>
              <h5>{{ lesson.title }}</h5>
            </div>
          </a>
        </div>
      {% empty %}
        <div class="error">
          <h5>пока уроков нет</h5>
        </div>
      {% endfor %}
  </div>
</div>
{% endspaceless %}
{% endblock content %}